#!/usr/bin/env python
# Storm mini Evolution clone by Damien Tanner (dctanner@xoasis.com)      
#
# This file is part of Storm.
#
#    Storm is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    Foobar is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.

#    You should have received a copy of the GNU General Public License
#    along with Storm; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

import re, sys, os, dbhash

if len(sys.argv) < 2:
	print "evo2storm\nUsage: python evo2storm.py [ipaqusername]@[ipaqip]"
	sys.exit(1)

def open_vcard(vcard_source):
	first_level = re.compile('BEGIN:VCARD([0-9A-Za-z \t\n\r<>\(\)=\.@\-:;,/\\\-_]*?)END:VCARD')
	vcard_output = re.findall(first_level, vcard_source)
	if len(vcard_output) > 0:
		return vcard_output[0]
	else:
		return ''

def get_vcard_data(vcard_source, tag):
	second_level = re.compile(tag + '([0-9A-Za-z \t\n\r<>\(\)=\.@\-:;,/\\\-_]*?)\r\n')
	vcard_output = re.findall(second_level, vcard_source)
	if len(vcard_output) > 0:
		return vcard_output[0]
	else:
		return ''

file = open("/tmp/contacts.xml", "w")
file.write('')
file.close()

db = dbhash.open(os.environ['HOME'] + "/evolution/local/Contacts/addressbook.db", "r")

x = 0
z = len(db.keys())
db.first()
while x < z - 1:
	vcard_key = db.next()
	vcard_data = open_vcard(vcard_key[1])
	if vcard_data != '':
		file = open("/tmp/contacts.xml", "a")
		file.write("<contact>\n")
		file.write("<name>" + get_vcard_data(vcard_data, "FN:") + "</name>\n")
		file.write("<email>" + get_vcard_data(vcard_data, "EMAIL;INTERNET:") + "</email>\n")
		file.write("<nickname>" + get_vcard_data(vcard_data, "NICKNAME:") + "</nickname>\n")
		file.write("<company>" + get_vcard_data(vcard_data, "ORG:") + "</company>\n")
		file.write("<birthday>" + get_vcard_data(vcard_data, "BDAY:") + "</birthday>\n")
		file.write("<website>" + get_vcard_data(vcard_data, "URL:") + "</website>\n")
		file.write("<mobilephone>" + get_vcard_data(vcard_data, "TEL;CELL;VOICE:") + "</mobilephone>\n")
		file.write("<homephone>" + get_vcard_data(vcard_data, "TEL;HOME;VOICE:") + "</homephone>\n")
		file.write("<businessphone>" + get_vcard_data(vcard_data, "TEL;WORK;VOICE:") + "</businessphone>\n")
		file.write("<notes>" + get_vcard_data(vcard_data, "NOTE:") + "</notes>\n")
		file.write("</contact>\n\n")
		file.close()
	x = x + 1

os.system("rsync -e ssh /tmp/contacts.xml " + sys.argv[1] + ":/usr/local/share/storm/data/contacts.xml")
os.system("rm /tmp/contacts.xml")
print "Sync complete!"