#!/usr/bin/env python
# Storm mini Evolution clone by Damien Tanner (dctanner@xoasis.com)      
#
# This file is part of Storm.
#
#    Storm is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    Storm is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.

#    You should have received a copy of the GNU General Public License
#    along with Storm; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

from gtk import *

class Help:
	def __init__(self, parent):
		self.parent = parent

	def about(self, *args):
		'''Opens up an about window.'''

		# our main gtk window
		window = GtkWindow(WINDOW_TOPLEVEL)
		window.connect("delete_event", window.hide)
		window.set_title("Storm - Help")
		window.set_usize(200, 200)
        	window.set_position(WIN_POS_CENTER)
		window.show()

		vbox = GtkVBox()
		window.add(vbox)
		vbox.show()

		pix, mask = create_pixmap_from_xpm(self.parent.window, None, self.parent.config[2] + "/pixmaps/storm.xpm")
		pixmap = GtkPixmap(pix, mask)
		vbox.pack_start(pixmap, expand=FALSE)
		pixmap.show()

		scroll = GtkScrolledWindow()
		scroll.set_policy(POLICY_NEVER, POLICY_AUTOMATIC)
		vbox.pack_start(scroll)
		scroll.show()

		text = GtkText()
		scroll.add(text)
		text.insert(None,None,None,"Storm v0.5\n\nProgramming By:\nDamein Tanner (dctanner@xoasis.com)\n\nThanks to:\nTed Poe\nTom Vogt\nRobert W Vawter\nJonathan Pennington\nLionel Ulmer\n")
		vadjust = scroll.get_vadjustment()
		vadjust.set_value(0)
		text.show()

		button = GtkButton("Close")
		button.connect("clicked", window.hide)
		vbox.pack_start(button, expand=FALSE)
		button.show()
