#!/usr/bin/env python
# Storm mini Evolution clone by Damien Tanner (dctanner@xoasis.com)      
#
# This file is part of Storm.
#
#    Storm is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    Storm is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.

#    You should have received a copy of the GNU General Public License
#    along with Storm; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

from gtk import *
import time, rfc822, string, os, socket

class Mail:
	def __init__(self, parent):
		self.parent = parent		
		self.cmap = self.parent.window.get_colormap()

		# start the gui

		frame = GtkVBox()
		frame.show()

		hbox1 = GtkHBox()
		frame.pack_start(hbox1, expand=FALSE)
		hbox1.show()

		self.folders_menu = GtkMenu()
		self.folders_menu.show()
		for self.folder in os.listdir(self.parent.config[2] + '/maildir'):
			if self.folder != "CVS":
				print self.folder
				folder_menuitem = GtkMenuItem(self.folder)
				folder_menuitem.connect("activate", self.select_folder, self.folder)
				self.folders_menu.append(folder_menuitem)
				folder_menuitem.show()

		self.folders_optionmenu = GtkOptionMenu()
		self.folders_optionmenu.set_menu(self.folders_menu)
		hbox1.pack_start(self.folders_optionmenu, expand=FALSE)
		self.folders_optionmenu.show()

		self.current_folder = "Inbox"

		hsep = GtkHSeparator()
		hbox1.pack_start(hsep)
		hsep.show()

		headers = []
		vbox = GtkVBox()
		frame.pack_start(vbox)
		vbox.show()

		hbox2 = GtkHBox()
		vbox.pack_start(hbox2, expand=FALSE)
		hbox2.show()

		# make the toobar
		toolbar = GtkToolbar(ORIENTATION_HORIZONTAL, TOOLBAR_ICONS)
		toolbar.set_button_relief(RELIEF_NONE)
		toolbar.set_space_size(10)
		hbox2.pack_start(toolbar, expand=FALSE)
		toolbar.show()
		# add the evolution pixmaps to the toolbar
		pix, mask = create_pixmap_from_xpm(self.parent.window, None, self.parent.config[2] + "/pixmaps/read.xpm")
		toolbar.append_item(None, 'Read selected message', None, GtkPixmap(pix, mask), self.read_message)

		pix, mask = create_pixmap_from_xpm(self.parent.window, None, self.parent.config[2] + "/pixmaps/new.xpm")
		toolbar.append_item(None, 'Compose a new message', None, GtkPixmap(pix, mask), self.new_message)

		pix, mask = create_pixmap_from_xpm(self.parent.window, None, self.parent.config[2] + "/pixmaps/edit.xpm")
		toolbar.append_item(None, 'Edit the selected message', None, GtkPixmap(pix, mask), self.edit_message)

		pix, mask = create_pixmap_from_xpm(self.parent.window, None, self.parent.config[2] + "/pixmaps/reply.xpm")
		toolbar.append_item(None, 'Reply to the select message', None, GtkPixmap(pix, mask), self.reply_message)

		pix, mask = create_pixmap_from_xpm(self.parent.window, None, self.parent.config[2] + "/pixmaps/trash.xpm")
		toolbar.append_item(None, 'Delete the selected message', None, GtkPixmap(pix, mask), self.delete_message)

		toolbar2 = GtkToolbar(ORIENTATION_HORIZONTAL, TOOLBAR_ICONS)
		toolbar2.set_button_relief(RELIEF_NONE)
		toolbar2.set_space_size(10)
		hbox2.pack_end(toolbar2, expand=FALSE)
		toolbar2.show()
		# add the evolution pixmaps to the toolbar
		pix, mask = create_pixmap_from_xpm(self.parent.window, None, self.parent.config[2] + "/pixmaps/list.xpm")
		toolbar2.append_item(None, 'Show Column Names', None, GtkPixmap(pix, mask), self.clist_titles_change)

		cscroll = GtkScrolledWindow()
		cscroll.set_policy(POLICY_AUTOMATIC, POLICY_AUTOMATIC)
		vbox.pack_start(cscroll)
		cscroll.show()

		clist=GtkCList(3)
		cscroll.add(clist)
		clist.connect("select-row" , self.select_message)
		clist.connect("click-column" , self.select_clist_column)
		clist.set_flags(CAN_FOCUS)
		clist.set_usize(-1, -1)
		clist.set_column_title(0, "From")
		clist.set_column_title(1, "Subject")
		clist.set_column_title(2, "Date")
		clist.set_column_width(0, 80)
		clist.set_column_width(1, 80)
		clist.set_column_width(2, 35)
		clist.set_selection_mode(SELECTION_SINGLE)
		clist.column_titles_hide()
		self.clist_titles_state = FALSE
		clist.show()
		self.clist=clist
		frame.show()
		self.frame=frame

		self.deliverycount = 0
		self.read_maildir()
		self.selected_message = ''

	def clist_titles_change(self, *args):
		'''Called when the column titles button is pressed.'''

		# - If the column titles are hidden, show them, and vice versa
		if self.clist_titles_state == FALSE:
			self.clist.column_titles_show()
			self.clist_titles_state = TRUE
		else:
			self.clist.column_titles_hide()
			self.clist_titles_state = FALSE

	def select_clist_column(self, *args):
		'''Called when a comumn title is clicked, then sorts the list by it.'''

		self.update_list(args[1])

	def select_folder(self, *args):
		'''Called when a folder is selected.'''

		self.current_folder = args[1]
		self.read_maildir()

	def read_maildir(self):
		'''Reads the current maildir folder.'''

		self.message = []

		# - Read the 2 maildir subdirectorys
		for maildir_folder in ['new','cur']:

			# - List the messages/files in the directorys
			messages = os.listdir(self.parent.config[2] + '/maildir/' + self.current_folder + '/' + maildir_folder)

			# - Loop through them all
			for message_file in messages:
				
				if message_file != "CVS":

					# - Open and read each one
					file = open(self.parent.config[2] + '/maildir/' + self.current_folder + '/' + maildir_folder + '/' + message_file)
					full_message = file.read()
					file.close()
					
					# - Split the headers from the main message, and save them in a temp file
					message_parts = string.split(full_message, '\n\n', 1)
					# - Make sure the message actualy has some headers
					if len(message_parts) > 1:
						tmp_file = open("/tmp/storm.tmp", 'w')
						tmp_file.write(message_parts[0])
						tmp_file.close()
						tmp_file = open("/tmp/storm.tmp", 'r')

						# - Use the rfc822 module to get some headers
						header = rfc822.Message(tmp_file)
						headers = []

						for header_name in ['From', 'To', 'Date', 'Subject']:
							mail_header = header.getheader(header_name)

							# - If there's no such header just put a blank string instead
							if mail_header == None:
								headers.append('')

							else:
								headers.append(mail_header)

						tmp_file.close()

						# - Append the other message parts to our temp list
						headers.append(message_parts[0])
						headers.append(message_parts[1])
						headers.append(message_file)
						headers.append(maildir_folder)

						# - Add the temp list to the main messages list
						self.message.append(headers)

		self.update_list()

	def update_list(self, column=''):
		'''Updates the messages list.'''

		# - If there's a column varible passed sort the messages by it
		if column != '':
			self.message.sort(lambda x, y, column=column: cmp(x[column], y[column]))

		clist_color = self.cmap.alloc("grey87");
		v = 0

		# - Clear and freeze the list for good looks
		self.clist.clear()
		self.clist.freeze()

		x = 0

		while x < len(self.message):

			# - Append the message headers to the list
			self.clist.append([self.message[x][0], self.message[x][3], self.message[x][2]])

			if v == 0:
				self.clist.set_background(x, clist_color)
				v = 1
			else:
				v = 0
			x = x + 1

		self.clist.thaw()

	def select_message(self, *args):
		'''Called when a message is selected form the list.'''

		self.selected_message = args[1]

	def new_message(self, *args):
		'''Opens up a new message window.'''

		self.do_message("new")

	def reply_message(self, *args):
		'''Opens up a reply message window.'''

		self.do_message("reply")

	def reply_read_message(self, *args):
		'''Opens up a reply message window. From a read window'''

		self.read_window.hide()
		self.do_message("reply")

	def edit_message(self, *args):
		'''Edits the selected message.'''

		self.do_message("edit")

	def read_message(self, *args):
		'''Reads the selected message.'''

		if self.selected_message != '':

			if self.message[self.selected_message][7] == "new":
				os.rename(self.parent.config[2] + '/maildir/' + self.current_folder + '/new/' + self.message[self.selected_message][6], self.parent.config[2] + '/maildir/' + self.current_folder + '/cur/' + self.message[self.selected_message][6])

			self.do_message("read")

	def delete_message(self, *args):
		'''Deletes the selected message.'''

		# - Delete the actualy maildir folder
		os.unlink(self.parent.config[2] + '/maildir/' + self.current_folder + '/' + self.message[self.selected_message][7] + '/' + self.message[self.selected_message][6])

		# - Delete the current data of it
		del self.message[self.selected_message]

		# - Remove it from the messages list
		self.clist.remove(self.selected_message)

		# - Update the number of messages on the today page
		self.parent.today.update_today()

	def delete_read_message(self, *args):
		'''Deletes the selected message.'''

		# - Close the current read window
		self.read_window.hide()

		# - Delete the actualy maildir folder
		os.unlink(self.parent.config[2] + '/maildir/' + self.current_folder + '/' + self.message[self.selected_message][7] + '/' + self.message[self.selected_message][6])

		# - Delete the current data of it
		del self.message[self.selected_message]

		# - Remove it from the messages list
		self.clist.remove(self.selected_message)

		# - Update the number of messages on the today page
		self.parent.today.update_today()

	def send_message_now(self, *args):
		'''Sends the current message and syncs stright away.'''

		self.send_message()
		self.parent.sync.smtp()

	def send_message(self, *args):
		'''Sends the current message.'''

		# - Get the current date
		thedate = time.strftime("%a, %d %b %Y %X", time.gmtime(time.time()))
		thedate = string.strip(thedate)

		# - Get the values of the entry boxes
		to_text = self.to_entry.get_text()
		from_text = self.from_entry.get_text()
		subject_text = self.subject_entry.get_text()
		message_text = self.message_text.get_chars(0, -1)

		# - Open up a new maildir message
		filename = self.parent.config[2] + '/maildir/Outbox/new/' + str(time.time()) + '.' + str(os.getpid()) + '_' + str(self.deliverycount) + '.' + str(socket.gethostname())
		file = open(filename, 'w')

		# - Write the message to it
		file.write("To: " + to_text + "\n" + "Subject: " + subject_text + "\n" + "From: " + from_text + "\n" + "Reply-To: " + self.parent.config[1] + "\n" + "Date: " + thedate + "\n\n" + message_text)

		file.close()

		# - If we're in the Outbox folder, update the message list
		if self.current_folder == "Outbox":

			# - Add the message to the message list
			self.message.append([from_text,to_text,thedate,subject_text,"To: " + to_text + "\n" + "Subject: " + subject_text + "\n" + "From: " + from_text + "\n" + "Reply-To: " + self.parent.config[1] + "\n" + "Date: " + thedate,message_text])

			# - Update the list
			self.clist.append([from_text,subject_text,thedate])

		# - Update the number of messages on the today page
		self.parent.today.update_today()

		# - Close the current read window
		self.read_window.hide()

		# - Increment the delivery count for maildir
		self.deliverycount = self.deliverycount + 1

	def save_edited_message(self, *args):
		'''Saves and edited message.'''

		# - Overwite the old varibles
		self.message[self.selected_message][0] = self.from_entry.get_text()
		self.message[self.selected_message][1] = self.to_entry.get_text()
		self.message[self.selected_message][3] = self.subject_entry.get_text()
		self.message[self.selected_message][5] = self.message_text.get_chars(0, -1)

		# - Get the current date
		thedate = time.strftime("%a, %d %b %Y %X", time.gmtime(time.time()))
		thedate = string.strip(thedate)

		# - Open the maildir message file and write in the new data
		file = open(self.parent.config[2] + '/maildir/' + self.current_folder + '/' + self.message[self.selected_message][7] + '/' + self.message[self.selected_message][6], 'w')
		file.write("To: " + self.message[self.selected_message][1] + "\n" + "Subject: " + self.message[self.selected_message][3] + "\n" + "From: " + self.message[self.selected_message][0] + "\n" + "Reply-To: " + self.parent.config[1] + "\n" + "Date: " + thedate + "\n\n" + self.message[self.selected_message][5])
		file.close()

		# - Update the message list
		self.clist.set_text(self.selected_message,0,self.message[self.selected_message][0])
		self.clist.set_text(self.selected_message,1,self.message[self.selected_message][3])
		self.clist.set_text(self.selected_message,2,thedate)

		self.read_window.hide()

	def new_contact(self, *args):
		'''Makes a new contact from a message.'''

		# - Get the from email address
		to = self.to_entry.get_text()
		to = string.strip(to)

		# - Extract the name and email
		to_re = re.compile('^["]?(.*)["]?[ ]?<(.*)>$')
		data = re.findall(to_re, to)

		# - Make the new contact
		self.parent.contacts.do_contact("new", data[0][0], data[0][1])

	def select_to(self, *args):
		'''Select a contact from the list.'''

		# our main gtk window
		window = GtkWindow(WINDOW_TOPLEVEL)
		self.select_name_window = window
		window.connect("delete_event", window.hide)
		window.set_title("Storm - Contacts")
		window.set_usize(200, 200)
		window.show()

		scroll = GtkScrolledWindow()
		scroll.set_policy(POLICY_NEVER, POLICY_ALWAYS)
		window.add(scroll)
		scroll.show()

		clist = GtkCList(2)
		self.select_name_clist = clist
		scroll.add(clist)
		clist.connect("select_row" , self.select_name_return)
		clist.set_flags(CAN_FOCUS)
		clist.set_sort_column(0)
		clist.set_usize(-1, -1)
		clist.set_column_title(0, "Name")
		clist.set_column_width(0, 80)
		clist.set_column_title(1, "Email")
		clist.set_column_width(1, 80)
		clist.set_selection_mode(SELECTION_SINGLE)
		clist.column_titles_show()
		clist.show()

		# - Update the list with contacts
		self.parent.contacts.update_list(clist)

	def select_name_return(self, *args):
		'''Called when a contact is selected.'''

		# - Get the selected contact
		x = args[1]

		# - Backup any previous contacts added
		to_text = self.to_entry.get_text()
		z = 0

		# - Extract the name and email
		while z < len(self.parent.contacts.contacts_config):

			if self.parent.contacts.contacts_config[z][2] == "name":
				mname = self.parent.contacts.contact[x][z]

			elif self.parent.contacts.contacts_config[z][2] == "email":
				memail = self.parent.contacts.contact[x][z]

			z = z + 1

		# - If there was no previously added contacts, just add it
		if to_text == '':
			self.to_entry.set_text('"' + mname + '" <' + memail + '>')

		# - Otherwise put a , inbetween fro multiple contacts
		else:
			self.to_entry.set_text(to_text + ', "' + mname + '" <' + memail + '>')

		# - Hide the contacts select window
		self.select_name_window.hide()

	def do_message(self, mtype):
		'''Main gui message window. Used for making and editing email messages.'''

		# our main gtk window
		window = GtkWindow(WINDOW_TOPLEVEL)
		self.read_window = window
		window.connect("delete_event", window.hide)
		if mtype != "new":
			window.set_title("Storm - " + self.message[self.selected_message][3])
		else:
			window.set_title("Storm - Message")
		if screen_width() > 300:
			window.set_usize(280, 240)
		else:
			window.set_usize(240, 280)
		window.show()

		vbox = GtkVBox()
		window.add(vbox)
		vbox.show()

		# make the toobar
		toolbar = GtkToolbar(ORIENTATION_HORIZONTAL, TOOLBAR_ICONS)
		toolbar.set_button_relief(RELIEF_NONE)
		toolbar.set_space_size(10)
		vbox.pack_start(toolbar, expand=FALSE)
		toolbar.show()
		# add the evolution pixmaps to the toolbar
		if mtype == "read":
			pix, mask = create_pixmap_from_xpm(window, None, self.parent.config[2] + "/pixmaps/reply.xpm")
			toolbar.append_item(None, 'Reply to the current message', None, GtkPixmap(pix, mask), self.reply_message)

			pix, mask = create_pixmap_from_xpm(window, None, self.parent.config[2] + "/pixmaps/trash.xpm")
			toolbar.append_item(None, 'Delete the current message', None, GtkPixmap(pix, mask), self.delete_read_message)
		elif mtype == "edit":
			pix, mask = create_pixmap_from_xpm(window, None, self.parent.config[2] + "/pixmaps/save.xpm")
			toolbar.append_item(None, 'Delete the current message', None, GtkPixmap(pix, mask), self.save_edited_message)
		else:
			pix, mask = create_pixmap_from_xpm(window, None, self.parent.config[2] + "/pixmaps/send-later.xpm")
			toolbar.append_item(None, 'Send the current message', None, GtkPixmap(pix, mask), self.send_message)

			pix, mask = create_pixmap_from_xpm(window, None, self.parent.config[2] + "/pixmaps/send.xpm")
			toolbar.append_item(None, 'Send the current message', None, GtkPixmap(pix, mask), self.send_message_now)

		pix, mask = create_pixmap_from_xpm(window, None, self.parent.config[2] + "/pixmaps/cancel.xpm")
		toolbar.append_item(None, 'Close this window', None, GtkPixmap(pix, mask), window.hide)

		to_hbox = GtkHBox()
		vbox.pack_start(to_hbox, expand=FALSE)
		to_hbox.show()
		to_button = GtkButton()
		to_hbox.pack_start(to_button, expand=FALSE)
		to_button.show()
		message_tips = GtkTooltips()
		if mtype == "read" or mtype == "edit":
			message_tips.set_tip(to_button, 'Add contact to address book')
			to_button.connect("clicked", self.new_contact)
			pix, mask = create_pixmap_from_xpm(window, None, self.parent.config[2] + "/pixmaps/contacts-add.xpm")
			to_pixmap = GtkPixmap(pix, mask)
		else:
			message_tips.set_tip(to_button, 'Select a recipient from the address book')
			to_button.connect("clicked", self.select_to)
			pix, mask = create_pixmap_from_xpm(window, None, self.parent.config[2] + "/pixmaps/contacts.xpm")
			to_pixmap = GtkPixmap(pix, mask)
		to_button.add(to_pixmap)
		to_pixmap.show()
		to_entry = GtkEntry()
		if mtype == "read":
			to_entry.set_editable(FALSE)
			to_entry.set_text(self.message[self.selected_message][0])
		elif mtype == "reply":
			to_entry.set_editable(TRUE)
			to_entry.set_text(self.message[self.selected_message][0])
		if mtype == "edit":
			to_entry.set_editable(TRUE)
			to_entry.set_text(self.message[self.selected_message][1])
		else:
			to_entry.set_editable(TRUE)
		to_hbox.pack_start(to_entry)
		to_entry.show()
		self.to_entry = to_entry
		from_entry = GtkEntry()
		if mtype == "read":
			from_entry.set_editable(FALSE)
			from_entry.set_text(self.message[self.selected_message][2])
		elif mtype == "reply" or mtype == "new":
			from_entry.set_editable(TRUE)
			from_entry.set_text('"' + self.parent.config[0] + '" <' + self.parent.config[1] + '>')
		if mtype == "edit":
			from_entry.set_editable(TRUE)
			from_entry.set_text(self.message[self.selected_message][0])
		else:
			from_entry.set_editable(TRUE)
		vbox.pack_start(from_entry, expand=FALSE)
		from_entry.show()
		self.from_entry = from_entry

		subject_entry = GtkEntry()
		if mtype == "read":
			subject_entry.set_editable(FALSE)
			subject_entry.set_text(self.message[self.selected_message][3])
		if mtype == "edit":
			subject_entry.set_editable(TRUE)
			subject_entry.set_text(self.message[self.selected_message][3])
		elif mtype == "reply":
			subject_entry.set_editable(TRUE)
			subject_entry.set_text('Re: ' + self.message[self.selected_message][3])
		else:
			subject_entry.set_editable(TRUE)
		vbox.pack_start(subject_entry, expand=FALSE)
		subject_entry.show()
		self.subject_entry = subject_entry
		scroll = GtkScrolledWindow()
		scroll.set_policy(POLICY_NEVER, POLICY_ALWAYS)
		vbox.pack_start(scroll)
		scroll.show()

		text = GtkText()
		self.message_text = text
		if mtype == "read":
			text.set_editable(FALSE)
		else:
			text.set_editable(TRUE)
		scroll.add(text)
		text.show()
		text.freeze()
		if mtype == "read" or mtype == "edit":
			text.insert(None, None, None, self.message[self.selected_message][5])
		elif mtype == "reply":
			sig_file = open(self.parent.config[2] + '/config/sig', 'r')
			sig = sig_file.read()
			sig_file.close()

			o_lines = string.split(self.message[self.selected_message][5], '\n')
			m_text = ''
			for o_line in o_lines:
				m_text = m_text + '> ' + o_line + '\n'
			m_text_head = '\n> -----Original Message-----\n> From: ' + self.message[self.selected_message][0] + '\n> Subject: ' + self.message[self.selected_message][3] + '\n> Date: ' + self.message[self.selected_message][2] + '\n> \n'
			text.insert(None, None, None, '\n\n' + '-- \n' + sig + '\n' + m_text_head + m_text)
		elif mtype == "new":
			sig_file = open(self.parent.config[2] + '/config/sig', 'r')
			sig = sig_file.read()
			sig_file.close()
			text.insert(None, None, None, '\n\n' + '-- \n' + sig)
		vadjust = scroll.get_vadjustment()
		vadjust.set_value(0)
		text.thaw()
