#!/usr/bin/env python
# Storm mini Evolution clone by Damien Tanner (dctanner@xoasis.com)      
#
# This file is part of Storm.
#
#    Storm is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    Storm is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.

#    You should have received a copy of the GNU General Public License
#    along with Storm; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

from gtk import *

class StormLoad:
	def __init__(self, parent):
		self.parent = parent

		# our main gtk window
		window = GtkWindow(WINDOW_TOPLEVEL)
		window.connect("delete_event", window.hide)
		window.set_position(WIN_POS_CENTER)
		window.set_title("Storm - Sync")
		window.set_usize(180, -1)
		window.show()
		self.window = window

		hbox = GtkHBox()
		window.add(hbox)
		hbox.show()

		label = GtkLabel()
		hbox.pack_start(label, expand=FALSE)
		label.set_text("Loading Storm... ")
		label.show()

		table1=GtkTable(5, 1)
		hbox.pack_start(table1)
		table1.set_usize(-1, -1)
		table1.set_row_spacings(0)
		table1.set_col_spacings(3)
		table1.show()

		pix, mask = create_pixmap_from_xpm(self.parent.window, None, self.parent.config[2] + "/pixmaps/storm-today-mini.xpm")
		self.today_pixmap = GtkPixmap(pix, mask)
		table1.attach(self.today_pixmap, 0, 1, 0, 1, FILL, 0, 0, 0)

		pix, mask = create_pixmap_from_xpm(self.parent.window, None, self.parent.config[2] + "/pixmaps/storm-inbox-mini.xpm")
		self.inbox_pixmap = GtkPixmap(pix, mask)
		table1.attach(self.inbox_pixmap, 1, 2, 0, 1, FILL, 0, 0, 0)

		pix, mask = create_pixmap_from_xpm(self.parent.window, None, self.parent.config[2] + "/pixmaps/storm-calendar-mini.xpm")
		self.calendar_pixmap = GtkPixmap(pix, mask)
		table1.attach(self.calendar_pixmap, 2, 3, 0, 1, FILL, 0, 0, 0)

		pix, mask = create_pixmap_from_xpm(self.parent.window, None, self.parent.config[2] + "/pixmaps/storm-contacts-mini.xpm")
		self.contacts_pixmap = GtkPixmap(pix, mask)
		table1.attach(self.contacts_pixmap, 3, 4, 0, 1, FILL, 0, 0, 0)

		pix, mask = create_pixmap_from_xpm(self.parent.window, None, self.parent.config[2] + "/pixmaps/storm-notes-mini.xpm")
		self.notes_pixmap = GtkPixmap(pix, mask)
		table1.attach(self.notes_pixmap, 4, 5, 0, 1, FILL, 0, 0, 0)

		pix, mask = create_pixmap_from_xpm(self.parent.window, None, self.parent.config[2] + "/pixmaps/storm-tasks-mini.xpm")
		self.tasks_pixmap = GtkPixmap(pix, mask)
		table1.attach(self.notes_pixmap, 4, 5, 0, 1, FILL, 0, 0, 0)
