#!/usr/bin/env python
# Storm mini Evolution clone by Damien Tanner (dctanner@xoasis.com)      
#
# This file is part of Storm.
#
#    Storm is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    Storm is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.

#    You should have received a copy of the GNU General Public License
#    along with Storm; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

from gtk import *
import time, string ,os

class Today:
	def __init__(self, parent):
		self.parent = parent

		date = time.strftime("%d %b %Y", time.gmtime(time.time()))
		self.day, self.month, self.year = string.split(date)

		frame = GtkFrame()
		frame.set_usize(-1, -1)
		frame.set_shadow_type("GTK_SHADOW_ETCHED_IN")
		frame.set_label("Today")
		frame.set_label_align(0, -1)

		vbox1=GtkVBox()
		frame.add(vbox1)
		vbox1.set_usize(-1, -1)
		vbox1.set_homogeneous(FALSE)
		vbox1.set_spacing(0)
		hbox1=GtkHBox()
		vbox1.pack_start(hbox1, TRUE, TRUE, 0)
		hbox1.set_usize(-1, -1)
		hbox1.set_homogeneous(FALSE)
		hbox1.set_spacing(0)
		pix, mask = create_pixmap_from_xpm(self.parent.window, None, self.parent.config[2] + "/pixmaps/storm-today.xpm")
		today_pixmap=GtkPixmap(pix, mask)
		hbox1.pack_start(today_pixmap, FALSE, FALSE, 0)
		today_pixmap.set_usize(-1, -1)
		today_pixmap.set_alignment(0.5, 0.5)
		today_pixmap.set_padding(5, 0)
		today_pixmap.show()
		self.today_pixmap=today_pixmap
		today_label=GtkLabel()
		hbox1.pack_start(today_label, FALSE, FALSE, 0)
		today_label.set_usize(-1, -1)
		date_file = open(self.parent.config[2] + "/config/lastsync", 'r')
		thedate = date_file.read()
		date_file.close()
		today_label.set_text("Last syncronized:\n" + thedate)
		today_label.set_justify(JUSTIFY_LEFT)
		today_label.set_alignment(0.5, 0.5)
		today_label.set_padding(0, 0)
		today_label.show()
		self.today_label=today_label
		hbox1.show()
		self.hbox1=hbox1
		hbox2=GtkHBox()
		vbox1.pack_start(hbox2, TRUE, TRUE, 0)
		hbox2.set_usize(-1, -1)
		hbox2.set_homogeneous(FALSE)
		hbox2.set_spacing(0)
		pix, mask = create_pixmap_from_xpm(self.parent.window, None, self.parent.config[2] + "/pixmaps/storm-inbox.xpm")
		inbox_pixmap=GtkPixmap(pix, mask)
		hbox2.pack_start(inbox_pixmap, FALSE, FALSE, 0)
		inbox_pixmap.set_usize(-1, -1)
		inbox_pixmap.set_alignment(0.5, 0.5)
		inbox_pixmap.set_padding(5, 0)
		inbox_pixmap.show()
		self.inbox_pixmap=inbox_pixmap
		inbox_label=GtkLabel()
		hbox2.pack_start(inbox_label, FALSE, FALSE, 0)
		inbox_label.set_usize(-1, -1)
		inbox_label.set_justify(JUSTIFY_LEFT)
		inbox_label.set_alignment(0.5, 0.5)
		inbox_label.set_padding(0, 0)
		inbox_label.show()
		self.inbox_label=inbox_label
		hbox2.show()
		self.hbox2=hbox2
		hbox3=GtkHBox()
		vbox1.pack_start(hbox3, TRUE, TRUE, 0)
		hbox3.set_usize(-1, -1)
		hbox3.set_homogeneous(FALSE)
		hbox3.set_spacing(0)
		pix, mask = create_pixmap_from_xpm(self.parent.window, None, self.parent.config[2] + "/pixmaps/storm-calendar.xpm")
		calendar_pixmap=GtkPixmap(pix, mask)
		hbox3.pack_start(calendar_pixmap, FALSE, FALSE, 0)
		calendar_pixmap.set_usize(-1, -1)
		calendar_pixmap.set_alignment(0.5, 0.5)
		calendar_pixmap.set_padding(5, 0)
		calendar_pixmap.show()
		self.calendar_pixmap=calendar_pixmap
		calendar_label=GtkLabel()
		hbox3.pack_start(calendar_label, FALSE, FALSE, 0)
		calendar_label.set_usize(-1, -1)
		calendar_label.set_justify(JUSTIFY_LEFT)
		calendar_label.set_alignment(0.5, 0.5)
		calendar_label.set_padding(0, 0)
		calendar_label.show()
		self.calendar_label=calendar_label
		hbox3.show()

		hbox4=GtkHBox()
		vbox1.pack_start(hbox4, TRUE, TRUE, 0)
		hbox4.set_usize(-1, -1)
		hbox4.set_homogeneous(FALSE)
		hbox4.set_spacing(0)
		pix, mask = create_pixmap_from_xpm(self.parent.window, None, self.parent.config[2] + "/pixmaps/storm-time.xpm")
		time_pixmap=GtkPixmap(pix, mask)
		hbox4.pack_start(time_pixmap, FALSE, FALSE, 0)
		time_pixmap.set_usize(-1, -1)
		time_pixmap.set_alignment(0.5, 0.5)
		time_pixmap.set_padding(5, 0)
		time_pixmap.show()
		self.time_pixmap=time_pixmap
		hbox4.show()

		self.hbox3=hbox3
		vbox1.show()
		self.vbox1=vbox1

		self.update_today()

		frame.show()
		self.frame = frame

	def update_today(self, *args):
		'''Update the Today page with the latest things.'''

		# - Update the email message count
		maildir_folders = os.listdir(self.parent.config[2] + '/maildir')
		label_str = ''
		for folder in maildir_folders:
			if folder != "CVS":
				num = 0
				for sub_folder in ['new','cur']:
					# For each maildir folder count the number of messages
					num = num + len(os.listdir(self.parent.config[2] + '/maildir/' + folder + '/' + sub_folder))
				label_str = label_str + folder + ': ' + str(num) + '\n'
		# Add the text to the gtk label
		self.inbox_label.set_text(label_str[:-1])

		# - Update the number of appointments for today
		self.calendar_label.set_text(str(len(self.parent.calendar.appointment)) + ' Appointments Today')
