#!/usr/bin/env python
# Storm mini Evolution clone by Damien Tanner (dctanner@xoasis.com)      
#
# This file is part of Storm.
#
#    Storm is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    Storm is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.

#    You should have received a copy of the GNU General Public License
#    along with Storm; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

import re

class XmlParse:
	def __init__(self):
		pass

	def xml_get_text(self, xml_source, tag):
		second_level = re.compile('<'+tag+'>([0-9A-Za-z \t\n\r<>\.@\-:,/\\\-_]*?)</'+tag+'>')
		xml_output = re.findall(second_level, xml_source)
		if len(xml_output) > 0:
			return xml_output[0]
		else:
			return ''

	def parse_xml_file(self, xml_file, first_tag):
		# regexp for xml
		self.first_level = re.compile('<'+first_tag+'>([0-9A-Za-z \t\n\r<>\.@\-:,/\\\-_]*?)</'+first_tag+'>')
		# contacts xml file
		self.xml_file = xml_file

		# open and read the xml file
		file = open(self.xml_file, 'r')
		xml_source = file.read()
		file.close()

		# get the data for each contact
		xml_output = re.findall(self.first_level, xml_source)
		return xml_output
